您的位置:首页 > 产品设计 > UI/UE

【LeetCode】376.Wiggle Subsequence(Medium)解题报告

2018-03-08 15:04 519 查看
【LeetCode】376.Wiggle Subsequence(Medium)解题报告

题目地址:https://leetcode.com/problems/wiggle-subsequence/description/

题目描述:

  A sequence of numbers is called a wiggle sequence if the differences between successive numbers strictly alternate between positive and negative. The first difference (if one exists) may be either positive or negative. A sequence with fewer than two elements is trivially a wiggle sequence.

  For example, [1,7,4,9,2,5] is a wiggle sequence because the differences (6,-3,5,-7,3) are alternately positive and negative. In contrast, [1,4,7,2,5] and [1,7,4,5,5] are not wiggle sequences, the first because its first two differences are positive and the second because its last difference is zero.

  Given a sequence of integers, return the length of the longest subsequence that is a wiggle sequence. A subsequence is obtained by deleting some number of elements (eventually, also zero) from the original sequence, leaving the remaining elements in their original order.

Examples:
Input: [1,7,4,9,2,5]
Output: 6
The entire sequence is a wiggle sequence.

Input: [1,17,5,10,13,15,10,5,16,8]
Output: 7
There are several subsequences that achieve this length. One is [1,17,10,13,10,16,8].

Input: [1,2,3,4,5,6,7,8,9]
Output: 2


  Follow up: Can you do it in O(n) time?

Solution1:

//*
让摇摆序列的长度最长
dp
time : O(n)
space : O(n)
*/
class Solution {
public int wiggleMaxLength(int[] nums) {
if(nums.length == 0 || nums == null) return 0;
int[] up = new int[nums.length];
int[] down = new int[nums.length];

up[0]=1;
down[0]=1;
for(int i=1 ; i<nums.length ; i++){
if(nums[i]>nums[i-1]){
up[i] = down[i-1] + 1;
down[i] = down[i-1];
}else if(nums[i]<nums[i-1]){
down[i] = up[i-1] + 1;
up[i] = up[i-1];
}else{
down[i] = down[i-1];
up[i] = up[i-1];
}
}
return Math.max(down[nums.length-1],up[nums.length-1]);
}
}


Solution2:

/*
让摇摆序列的长度最长
dp
time : O(n)
space : O(1)
*/
class Solution {
public int wiggleMaxLength(int[] nums) {
if(nums.length == 0 || nums == null) return 0;
int up = 1;
int down = 1;
for(int i=1 ; i<nums.length ; i++){
if(nums[i]>nums[i-1]){
up = down + 1;
}else if(nums[i]<nums[i-1]){
down = up + 1;
}
}
return Math.max(down,up);
}
}


Date:2018年3月8日
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  leetcode array